/*
 * $Id$
 */

package org.apache.archiva.configuration;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * 
 *         The network configuration for external http request to
 * repositories.
 *       
 * 
 * @version $Revision$ $Date$
 */
public class NetworkConfiguration
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * maximum total external http connections.
     */
    private int maxTotal = 30;

    /**
     * maximum total external http connections per host.
     */
    private int maxTotalPerHost = 30;

    /**
     * use or not http connection pooling default true.
     */
    private boolean usePooling = true;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Get maximum total external http connections.
     * 
     * @return int
     */
    public int getMaxTotal()
    {
        return this.maxTotal;
    } //-- int getMaxTotal()

    /**
     * Get maximum total external http connections per host.
     * 
     * @return int
     */
    public int getMaxTotalPerHost()
    {
        return this.maxTotalPerHost;
    } //-- int getMaxTotalPerHost()

    /**
     * Get use or not http connection pooling default true.
     * 
     * @return boolean
     */
    public boolean isUsePooling()
    {
        return this.usePooling;
    } //-- boolean isUsePooling()

    /**
     * Set maximum total external http connections.
     * 
     * @param maxTotal
     */
    public void setMaxTotal( int maxTotal )
    {
        this.maxTotal = maxTotal;
    } //-- void setMaxTotal( int )

    /**
     * Set maximum total external http connections per host.
     * 
     * @param maxTotalPerHost
     */
    public void setMaxTotalPerHost( int maxTotalPerHost )
    {
        this.maxTotalPerHost = maxTotalPerHost;
    } //-- void setMaxTotalPerHost( int )

    /**
     * Set use or not http connection pooling default true.
     * 
     * @param usePooling
     */
    public void setUsePooling( boolean usePooling )
    {
        this.usePooling = usePooling;
    } //-- void setUsePooling( boolean )


}
