/*
 * $Id$
 */

package org.apache.archiva.configuration;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * Class RepositoryScanningConfiguration.
 * 
 * @version $Revision$ $Date$
 */
public class RepositoryScanningConfiguration
    implements java.io.Serializable
{

      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field fileTypes.
     */
    private java.util.List<FileType> fileTypes;

    /**
     * Field knownContentConsumers.
     */
    private java.util.List<String> knownContentConsumers;

    /**
     * Field invalidContentConsumers.
     */
    private java.util.List<String> invalidContentConsumers;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addFileType.
     * 
     * @param fileType
     */
    public void addFileType( FileType fileType )
    {
        if ( !(fileType instanceof FileType) )
        {
            throw new ClassCastException( "RepositoryScanningConfiguration.addFileTypes(fileType) parameter must be instanceof " + FileType.class.getName() );
        }
        getFileTypes().add( fileType );
    } //-- void addFileType( FileType )

    /**
     * Method addInvalidContentConsumer.
     * 
     * @param string
     */
    public void addInvalidContentConsumer( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "RepositoryScanningConfiguration.addInvalidContentConsumers(string) parameter must be instanceof " + String.class.getName() );
        }
        getInvalidContentConsumers().add( string );
    } //-- void addInvalidContentConsumer( String )

    /**
     * Method addKnownContentConsumer.
     * 
     * @param string
     */
    public void addKnownContentConsumer( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "RepositoryScanningConfiguration.addKnownContentConsumers(string) parameter must be instanceof " + String.class.getName() );
        }
        getKnownContentConsumers().add( string );
    } //-- void addKnownContentConsumer( String )

    /**
     * Method getFileTypes.
     * 
     * @return List
     */
    public java.util.List<FileType> getFileTypes()
    {
        if ( this.fileTypes == null )
        {
            this.fileTypes = new java.util.ArrayList<FileType>();
        }

        return this.fileTypes;
    } //-- java.util.List<FileType> getFileTypes()

    /**
     * Method getInvalidContentConsumers.
     * 
     * @return List
     */
    public java.util.List<String> getInvalidContentConsumers()
    {
        if ( this.invalidContentConsumers == null )
        {
            this.invalidContentConsumers = new java.util.ArrayList<String>();
        }

        return this.invalidContentConsumers;
    } //-- java.util.List<String> getInvalidContentConsumers()

    /**
     * Method getKnownContentConsumers.
     * 
     * @return List
     */
    public java.util.List<String> getKnownContentConsumers()
    {
        if ( this.knownContentConsumers == null )
        {
            this.knownContentConsumers = new java.util.ArrayList<String>();
        }

        return this.knownContentConsumers;
    } //-- java.util.List<String> getKnownContentConsumers()

    /**
     * Method removeFileType.
     * 
     * @param fileType
     */
    public void removeFileType( FileType fileType )
    {
        if ( !(fileType instanceof FileType) )
        {
            throw new ClassCastException( "RepositoryScanningConfiguration.removeFileTypes(fileType) parameter must be instanceof " + FileType.class.getName() );
        }
        getFileTypes().remove( fileType );
    } //-- void removeFileType( FileType )

    /**
     * Method removeInvalidContentConsumer.
     * 
     * @param string
     */
    public void removeInvalidContentConsumer( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "RepositoryScanningConfiguration.removeInvalidContentConsumers(string) parameter must be instanceof " + String.class.getName() );
        }
        getInvalidContentConsumers().remove( string );
    } //-- void removeInvalidContentConsumer( String )

    /**
     * Method removeKnownContentConsumer.
     * 
     * @param string
     */
    public void removeKnownContentConsumer( String string )
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "RepositoryScanningConfiguration.removeKnownContentConsumers(string) parameter must be instanceof " + String.class.getName() );
        }
        getKnownContentConsumers().remove( string );
    } //-- void removeKnownContentConsumer( String )

    /**
     * Set 
     *             The FileTypes for the repository scanning
     * configuration.
     *           
     * 
     * @param fileTypes
     */
    public void setFileTypes( java.util.List<FileType> fileTypes )
    {
        this.fileTypes = fileTypes;
    } //-- void setFileTypes( java.util.List )

    /**
     * Set 
     *             The list of active consumer IDs for invalid
     * content.
     *           
     * 
     * @param invalidContentConsumers
     */
    public void setInvalidContentConsumers( java.util.List<String> invalidContentConsumers )
    {
        this.invalidContentConsumers = invalidContentConsumers;
    } //-- void setInvalidContentConsumers( java.util.List )

    /**
     * Set 
     *             The list of active consumers IDs for known
     * content.
     *           
     * 
     * @param knownContentConsumers
     */
    public void setKnownContentConsumers( java.util.List<String> knownContentConsumers )
    {
        this.knownContentConsumers = knownContentConsumers;
    } //-- void setKnownContentConsumers( java.util.List )


}
